From fca6cd91898124da6cc8cbe79badeecbc5b6008d Mon Sep 17 00:00:00 2001
From: Wei Gao <gaowei66@huawei.com>
Date: Wed, 16 Dec 2020 03:41:09 -0500
Subject: [PATCH 1/2] crates: update kvm-ioctls from v0.5.0 to v0.6.0

Signed-off-by: Wei Gao <gaowei66@huawei.com>
---
 Cargo.lock                                         | 14 +++++++-------
 address_space/Cargo.toml                           |  2 +-
 boot_loader/Cargo.toml                             |  2 +-
 device_model/Cargo.toml                            |  2 +-
 license/Third_Party_Open_Source_Software_Notice.md |  4 ++--
 util/Cargo.toml                                    |  2 +-
 6 files changed, 13 insertions(+), 13 deletions(-)

diff --git a/Cargo.lock b/Cargo.lock
index 5e4be40..25deccf 100644
--- a/Cargo.lock
+++ b/Cargo.lock
@@ -26,7 +26,7 @@ version = "0.1.0"
 dependencies = [
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
- "kvm-ioctls 0.5.0 (git+https://github.com/rust-vmm/kvm-ioctls)",
+ "kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
  "machine_manager 0.1.0",
@@ -64,7 +64,7 @@ dependencies = [
  "address_space 0.1.0",
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
- "kvm-ioctls 0.5.0 (git+https://github.com/rust-vmm/kvm-ioctls)",
+ "kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
  "util 0.1.0",
@@ -90,7 +90,7 @@ dependencies = [
  "byteorder 1.3.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
- "kvm-ioctls 0.5.0 (git+https://github.com/rust-vmm/kvm-ioctls)",
+ "kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
  "machine_manager 0.1.0",
@@ -129,8 +129,8 @@ dependencies = [
 
 [[package]]
 name = "kvm-ioctls"
-version = "0.5.0"
-source = "git+https://github.com/rust-vmm/kvm-ioctls#f87ee798e2d782329b02942e2f9b4d0b5c0eb3c7"
+version = "0.6.0"
+source = "registry+https://github.com/rust-lang/crates.io-index"
 dependencies = [
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
@@ -251,7 +251,7 @@ version = "0.1.0"
 dependencies = [
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
- "kvm-ioctls 0.5.0 (git+https://github.com/rust-vmm/kvm-ioctls)",
+ "kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
  "vmm-sys-util 0.6.1 (registry+https://github.com/rust-lang/crates.io-index)",
@@ -282,7 +282,7 @@ dependencies = [
 "checksum gimli 0.21.0 (registry+https://github.com/rust-lang/crates.io-index)" = "bcc8e0c9bce37868955864dbecd2b1ab2bdf967e6f28066d65aaac620444b65c"
 "checksum itoa 0.4.5 (registry+https://github.com/rust-lang/crates.io-index)" = "b8b7a7c0c47db5545ed3fef7468ee7bb5b74691498139e4b3f6a20685dc6dd8e"
 "checksum kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)" = "8f1c07667561c3d12d77342baf28ca5d0f8c3ea2160778485640ec84a4571da2"
-"checksum kvm-ioctls 0.5.0 (git+https://github.com/rust-vmm/kvm-ioctls)" = "<none>"
+"checksum kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)" = "158d15da895bddca8223fa31dc9e8b9317bdc2fbc4635dea8dd575fc40dae37f"
 "checksum libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)" = "9457b06509d27052635f90d6466700c65095fdf75409b3fbdd903e988b886f49"
 "checksum log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)" = "14b6052be84e6b71ab17edffc2eeabf5c2c3ae1fdb464aae35ac50c67a44e1f7"
 "checksum miniz_oxide 0.3.7 (registry+https://github.com/rust-lang/crates.io-index)" = "791daaae1ed6889560f8c4359194f56648355540573244a5448a83ba1ecc7435"
diff --git a/address_space/Cargo.toml b/address_space/Cargo.toml
index d2d2791..b9a841f 100644
--- a/address_space/Cargo.toml
+++ b/address_space/Cargo.toml
@@ -11,7 +11,7 @@ machine_manager = {path = "../machine_manager"}
 
 libc = "0.2.71"
 kvm-bindings = "0.3.0"
-kvm-ioctls = { git = "https://github.com/rust-vmm/kvm-ioctls", branch = "master" }
+kvm-ioctls = "0.6.0"
 vmm-sys-util = "0.6.1"
 error-chain = "0.12.4"
 log = "0.4.8"
diff --git a/boot_loader/Cargo.toml b/boot_loader/Cargo.toml
index 189146b..5f3a32a 100644
--- a/boot_loader/Cargo.toml
+++ b/boot_loader/Cargo.toml
@@ -12,7 +12,7 @@ address_space = { path = "../address_space" }
 util = { path = "../util" }
 
 kvm-bindings = "0.3.0"
-kvm-ioctls = { git = "https://github.com/rust-vmm/kvm-ioctls", branch = "master" }
+kvm-ioctls = "0.6.0"
 vmm-sys-util = "0.6.1"
 
 libc = "0.2.71"
diff --git a/device_model/Cargo.toml b/device_model/Cargo.toml
index f1eb805..43de30f 100644
--- a/device_model/Cargo.toml
+++ b/device_model/Cargo.toml
@@ -9,7 +9,7 @@ license = "Mulan PSL v2"
 log = "0.4.8"
 libc = "0.2.71"
 kvm-bindings = "0.3.0"
-kvm-ioctls = { git = "https://github.com/rust-vmm/kvm-ioctls", branch = "master" }
+kvm-ioctls = "0.6.0"
 vmm-sys-util = "0.6.1"
 byteorder = "1.3.4"
 error-chain = "0.12.4"
diff --git a/license/Third_Party_Open_Source_Software_Notice.md b/license/Third_Party_Open_Source_Software_Notice.md
index a9674ea..51a17b2 100644
--- a/license/Third_Party_Open_Source_Software_Notice.md
+++ b/license/Third_Party_Open_Source_Software_Notice.md
@@ -342,7 +342,7 @@ THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-Software: kvm-ioctls 0.5.0
+Software: kvm-ioctls 0.6.0
 Copyright notice:
 Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 Portions Copyright 2017 The Chromium OS Authors. All rights reserved.
@@ -351,7 +351,7 @@ Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 License: MIT or Apache License Version 2.0
 Please see above.
 
-Software: kvm-bindings 0.2.0
+Software: kvm-bindings 0.3.0
 Copyright notice:
 Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 License: The APACHE 2.0 License
diff --git a/util/Cargo.toml b/util/Cargo.toml
index f4ff40f..857e37c 100644
--- a/util/Cargo.toml
+++ b/util/Cargo.toml
@@ -12,5 +12,5 @@ libc = "0.2.71"
 log = { version = "0.4.8", features = ["std"]}
 error-chain = "0.12.4"
 kvm-bindings = "0.3.0"
-kvm-ioctls = { git = "https://github.com/rust-vmm/kvm-ioctls", branch = "master" }
+kvm-ioctls = "0.6.0"
 vmm-sys-util = "0.6.1"
-- 
2.27.0